diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/internet/model/ipv6-l3-protocol.cc ns-3.41/src/internet/model/ipv6-l3-protocol.cc
--- ns-3.40/src/internet/model/ipv6-l3-protocol.cc	2023-09-27 13:30:37.658839200 -0700
+++ ns-3.41/src/internet/model/ipv6-l3-protocol.cc	2024-02-09 14:44:07.933790200 -0800
@@ -88,12 +88,6 @@
                           MakeBooleanAccessor(&Ipv6L3Protocol::SetSendIcmpv6Redirect,
                                               &Ipv6L3Protocol::GetSendIcmpv6Redirect),
                           MakeBooleanChecker())
-            .AddAttribute("StrongEndSystemModel",
-                          "Reject packets for an address not configured on the interface they're "
-                          "coming from (RFC1122, section 3.3.4.2).",
-                          BooleanValue(true),
-                          MakeBooleanAccessor(&Ipv6L3Protocol::m_strongEndSystemModel),
-                          MakeBooleanChecker())
             .AddTraceSource("Tx",
                             "Send IPv6 packet to outgoing interface.",
                             MakeTraceSourceAccessor(&Ipv6L3Protocol::m_txTrace),
@@ -1169,20 +1163,22 @@
                     LocalDeliver(packet, hdr, interface);
                     return;
                 }
-                else if (!m_strongEndSystemModel)
+                else if (!GetStrongEndSystemModel())
                 {
                     NS_LOG_LOGIC("For me (destination "
-                                 << addr << " match) on another interface with Weak ES Model"
+                                 << addr
+                                 << " match) on another interface with Weak End System Model"
                                  << hdr.GetDestination());
                     LocalDeliver(packet, hdr, interface);
                     return;
                 }
                 else
                 {
-                    NS_LOG_LOGIC("For me (destination "
-                                 << addr
-                                 << " match) on another interface with Strong ES Model - discarding"
-                                 << hdr.GetDestination());
+                    NS_LOG_LOGIC(
+                        "For me (destination "
+                        << addr
+                        << " match) on another interface with Strong End System Model - discarding"
+                        << hdr.GetDestination());
                     m_dropTrace(hdr, packet, DROP_NO_ROUTE, this, interface);
                     return;
                 }
@@ -1839,4 +1835,18 @@
     return true;
 }
 
+void
+Ipv6L3Protocol::SetStrongEndSystemModel(bool model)
+{
+    NS_LOG_FUNCTION(this << model);
+    m_strongEndSystemModel = model;
+}
+
+bool
+Ipv6L3Protocol::GetStrongEndSystemModel() const
+{
+    NS_LOG_FUNCTION(this);
+    return m_strongEndSystemModel;
+}
+
 } /* namespace ns3 */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/internet/model/ipv6-l3-protocol.h ns-3.41/src/internet/model/ipv6-l3-protocol.h
--- ns-3.40/src/internet/model/ipv6-l3-protocol.h	2023-09-27 13:30:37.658839200 -0700
+++ ns-3.41/src/internet/model/ipv6-l3-protocol.h	2024-02-09 14:44:07.933790200 -0800
@@ -707,6 +707,9 @@
      */
     virtual bool GetSendIcmpv6Redirect() const;
 
+    void SetStrongEndSystemModel(bool model) override;
+    bool GetStrongEndSystemModel() const override;
+
     /**
      * \brief Node attached to stack.
      */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/internet/model/ipv6-raw-socket-impl.cc ns-3.41/src/internet/model/ipv6-raw-socket-impl.cc
--- ns-3.40/src/internet/model/ipv6-raw-socket-impl.cc	2023-09-27 13:30:37.658839200 -0700
+++ ns-3.41/src/internet/model/ipv6-raw-socket-impl.cc	2024-02-09 14:44:07.933790200 -0800
@@ -139,7 +139,7 @@
 int
 Ipv6RawSocketImpl::Bind6()
 {
-    return (Bind());
+    return Bind();
 }
 
 int
@@ -534,25 +534,25 @@
 void
 Ipv6RawSocketImpl::Icmpv6FilterSetPass(uint8_t type)
 {
-    (m_icmpFilter.icmpv6Filt[(type) >> 5]) |= (uint32_t(1) << ((type)&31));
+    m_icmpFilter.icmpv6Filt[type >> 5] |= (uint32_t(1) << (type & 31));
 }
 
 void
 Ipv6RawSocketImpl::Icmpv6FilterSetBlock(uint8_t type)
 {
-    (m_icmpFilter.icmpv6Filt[(type) >> 5]) &= ~(uint32_t(1) << ((type)&31));
+    m_icmpFilter.icmpv6Filt[(type) >> 5] &= ~(uint32_t(1) << (type & 31));
 }
 
 bool
 Ipv6RawSocketImpl::Icmpv6FilterWillPass(uint8_t type)
 {
-    return (((m_icmpFilter.icmpv6Filt[(type) >> 5]) & (uint32_t(1) << ((type)&31))) != 0);
+    return ((m_icmpFilter.icmpv6Filt[type >> 5]) & (uint32_t(1) << (type & 31))) != 0;
 }
 
 bool
 Ipv6RawSocketImpl::Icmpv6FilterWillBlock(uint8_t type)
 {
-    return (((m_icmpFilter.icmpv6Filt[(type) >> 5]) & (uint32_t(1) << ((type)&31))) == 0);
+    return ((m_icmpFilter.icmpv6Filt[type >> 5]) & (uint32_t(1) << (type & 31))) == 0;
 }
 
 } /* namespace ns3 */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/internet/model/ipv6-route.cc ns-3.41/src/internet/model/ipv6-route.cc
--- ns-3.40/src/internet/model/ipv6-route.cc	2023-09-27 13:30:37.658839200 -0700
+++ ns-3.41/src/internet/model/ipv6-route.cc	2024-02-09 14:44:07.933790200 -0800
@@ -156,7 +156,7 @@
 std::map<uint32_t, uint32_t>
 Ipv6MulticastRoute::GetOutputTtlMap() const
 {
-    return (m_ttls);
+    return m_ttls;
 }
 
 std::ostream&
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/internet/model/rip.cc ns-3.41/src/internet/model/rip.cc
--- ns-3.40/src/internet/model/rip.cc	2023-09-27 13:30:37.662839200 -0700
+++ ns-3.41/src/internet/model/rip.cc	2024-02-09 14:44:07.937790400 -0800
@@ -99,7 +99,7 @@
             .AddAttribute("SplitHorizon",
                           "Split Horizon strategy.",
                           EnumValue(Rip::POISON_REVERSE),
-                          MakeEnumAccessor(&Rip::m_splitHorizonStrategy),
+                          MakeEnumAccessor<SplitHorizonType_e>(&Rip::m_splitHorizonStrategy),
                           MakeEnumChecker(Rip::NO_SPLIT_HORIZON,
                                           "NoSplitHorizon",
                                           Rip::SPLIT_HORIZON,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/internet/model/ripng.cc ns-3.41/src/internet/model/ripng.cc
--- ns-3.40/src/internet/model/ripng.cc	2023-09-27 13:30:37.662839200 -0700
+++ ns-3.41/src/internet/model/ripng.cc	2024-02-09 14:44:07.937790400 -0800
@@ -99,7 +99,7 @@
             .AddAttribute("SplitHorizon",
                           "Split Horizon strategy.",
                           EnumValue(RipNg::POISON_REVERSE),
-                          MakeEnumAccessor(&RipNg::m_splitHorizonStrategy),
+                          MakeEnumAccessor<SplitHorizonType_e>(&RipNg::m_splitHorizonStrategy),
                           MakeEnumChecker(RipNg::NO_SPLIT_HORIZON,
                                           "NoSplitHorizon",
                                           RipNg::SPLIT_HORIZON,
@@ -657,22 +657,23 @@
 
                     if (setSource)
                     {
-                        if (route->GetGateway().IsAny())
+                        // GetGateway().IsAny() means that the destination is reachable without a
+                        // gateway (is on-link). GetDest().IsAny() means that the route is the
+                        // default route. Having both true is very strange, but possible.
+                        // If the RT entry is specific for a destination, use that as a hint for the
+                        // source address to be used. Else, use the destination or the prefix to be
+                        // used stated in the RT entry.
+                        if (!route->GetDest().IsAny())
                         {
                             rtentry->SetSource(
                                 m_ipv6->SourceAddressSelection(interfaceIdx, route->GetDest()));
                         }
-                        else if (route->GetDest().IsAny()) /* default route */
+                        else
                         {
                             rtentry->SetSource(m_ipv6->SourceAddressSelection(
                                 interfaceIdx,
                                 route->GetPrefixToUse().IsAny() ? dst : route->GetPrefixToUse()));
                         }
-                        else
-                        {
-                            rtentry->SetSource(
-                                m_ipv6->SourceAddressSelection(interfaceIdx, route->GetDest()));
-                        }
                     }
 
                     rtentry->SetDestination(route->GetDest());
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/internet/model/tcp-cubic.cc ns-3.41/src/internet/model/tcp-cubic.cc
--- ns-3.40/src/internet/model/tcp-cubic.cc	2023-09-27 13:30:37.662839200 -0700
+++ ns-3.41/src/internet/model/tcp-cubic.cc	2024-02-09 14:44:07.937790400 -0800
@@ -45,6 +45,11 @@
                           BooleanValue(true),
                           MakeBooleanAccessor(&TcpCubic::m_fastConvergence),
                           MakeBooleanChecker())
+            .AddAttribute("TcpFriendliness",
+                          "Enable (true) or disable (false) TCP friendliness",
+                          BooleanValue(true),
+                          MakeBooleanAccessor(&TcpCubic::m_tcpFriendliness),
+                          MakeBooleanChecker())
             .AddAttribute("Beta",
                           "Beta for multiplicative decrease",
                           DoubleValue(0.7),
@@ -64,7 +69,7 @@
                           "Hybrid Slow Start detection mechanisms:"
                           "packet train, delay, both",
                           EnumValue(HybridSSDetectionMode::BOTH),
-                          MakeEnumAccessor(&TcpCubic::m_hystartDetect),
+                          MakeEnumAccessor<HybridSSDetectionMode>(&TcpCubic::m_hystartDetect),
                           MakeEnumChecker(HybridSSDetectionMode::PACKET_TRAIN,
                                           "PACKET_TRAIN",
                                           HybridSSDetectionMode::DELAY,
@@ -209,7 +214,7 @@
     if (tcb->m_cWnd >= tcb->m_ssThresh && segmentsAcked > 0)
     {
         m_cWndCnt += segmentsAcked;
-        uint32_t cnt = Update(tcb);
+        uint32_t cnt = Update(tcb, segmentsAcked);
 
         /* According to RFC 6356 even once the new cwnd is
          * calculated you must compare this to the number of ACKs received since
@@ -232,19 +237,24 @@
 }
 
 uint32_t
-TcpCubic::Update(Ptr<TcpSocketState> tcb)
+TcpCubic::Update(Ptr<TcpSocketState> tcb, uint32_t segmentsAcked)
 {
     NS_LOG_FUNCTION(this);
     Time t;
     uint32_t delta;
     uint32_t bicTarget;
     uint32_t cnt = 0;
+    uint32_t maxCnt;
     double offs;
     uint32_t segCwnd = tcb->GetCwndInSegments();
 
+    m_ackCnt += segmentsAcked;
+
     if (m_epochStart == Time::Min())
     {
         m_epochStart = Simulator::Now(); // record the beginning of an epoch
+        m_ackCnt = segmentsAcked;
+        m_tcpCwnd = segCwnd;
 
         if (m_lastMaxCwnd <= segCwnd)
         {
@@ -311,6 +321,26 @@
         cnt = m_cntClamp;
     }
 
+    if (m_tcpFriendliness)
+    {
+        auto scale = static_cast<uint32_t>(8 * (1024 + m_beta * 1024) / 3 / (1024 - m_beta * 1024));
+        delta = (segCwnd * scale) >> 3;
+        while (m_ackCnt > delta)
+        {
+            m_ackCnt -= delta;
+            m_tcpCwnd++;
+        }
+        if (m_tcpCwnd > segCwnd)
+        {
+            delta = m_tcpCwnd - segCwnd;
+            maxCnt = segCwnd / delta;
+            if (cnt > maxCnt)
+            {
+                cnt = maxCnt;
+            }
+        }
+    }
+
     // The maximum rate of cwnd increase CUBIC allows is 1 packet per
     // 2 packets ACKed, meaning cwnd grows at 1.5x per RTT.
     return std::max(cnt, 2U);
@@ -463,6 +493,8 @@
     m_lastMaxCwnd = 0;
     m_bicOriginPoint = 0;
     m_bicK = 0;
+    m_ackCnt = 0;
+    m_tcpCwnd = 0;
     m_delayMin = Time::Min();
     m_found = false;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/internet/model/tcp-cubic.h ns-3.41/src/internet/model/tcp-cubic.h
--- ns-3.40/src/internet/model/tcp-cubic.h	2023-09-27 13:30:37.662839200 -0700
+++ ns-3.41/src/internet/model/tcp-cubic.h	2024-02-09 14:44:07.937790400 -0800
@@ -104,6 +104,7 @@
 
   private:
     bool m_fastConvergence; //!< Enable or disable fast convergence algorithm
+    bool m_tcpFriendliness; //!< Enable or disable TCP-friendliness heuristic
     double m_beta;          //!< Beta for cubic multiplicative increase
 
     bool m_hystart;                        //!< Enable or disable HyStart algorithm
@@ -134,6 +135,8 @@
     Time m_cubicDelta;         //!<  Time to wait after recovery before update
     Time m_currRtt;            //!<  Current Rtt
     uint32_t m_sampleCnt;      //!<  Count of samples for HyStart
+    uint32_t m_ackCnt;         //!<  Count the number of ACKed packets
+    uint32_t m_tcpCwnd;        //!<  Estimated tcp cwnd (for Reno-friendliness)
 
   private:
     /**
@@ -151,9 +154,10 @@
     /**
      * \brief Cubic window update after a new ack received
      * \param tcb Transmission Control Block of the connection
+     * \param segmentsAcked Segments acked
      * \returns the congestion window update counter
      */
-    uint32_t Update(Ptr<TcpSocketState> tcb);
+    uint32_t Update(Ptr<TcpSocketState> tcb, uint32_t segmentsAcked);
 
     /**
      * \brief Update HyStart parameters
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/internet/model/tcp-dctcp.h ns-3.41/src/internet/model/tcp-dctcp.h
--- ns-3.40/src/internet/model/tcp-dctcp.h	2023-09-27 13:30:37.662839200 -0700
+++ ns-3.41/src/internet/model/tcp-dctcp.h	2024-02-09 14:44:07.937790400 -0800
@@ -33,7 +33,10 @@
  * \ingroup tcp
  *
  * \brief An implementation of DCTCP. This model implements all of the
- * endpoint capabilities mentioned in the DCTCP SIGCOMM paper.
+ * endpoint capabilities mentioned in the DCTCP SIGCOMM paper.  Note that
+ * this model presently will not do any fallback to RFC 5681 congestion
+ * avoidance as specified in RFC 8257 Section 3.5, so it should only be
+ * used in a simulation that does not involve packet loss.
  */
 
 class TcpDctcp : public TcpLinuxReno
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/internet/model/tcp-ledbat.cc ns-3.41/src/internet/model/tcp-ledbat.cc
--- ns-3.40/src/internet/model/tcp-ledbat.cc	2023-09-27 13:30:37.662839200 -0700
+++ ns-3.41/src/internet/model/tcp-ledbat.cc	2024-02-09 14:44:07.937790400 -0800
@@ -62,7 +62,7 @@
             .AddAttribute("SSParam",
                           "Possibility of Slow Start",
                           EnumValue(DO_SLOWSTART),
-                          MakeEnumAccessor(&TcpLedbat::SetDoSs),
+                          MakeEnumAccessor<SlowStartType>(&TcpLedbat::SetDoSs),
                           MakeEnumChecker(DO_SLOWSTART, "yes", DO_NOT_SLOWSTART, "no"))
             .AddAttribute("MinCwnd",
                           "Minimum cWnd for Ledbat",
@@ -102,7 +102,7 @@
     m_sndCwndCnt = 0;
     m_flag = LEDBAT_CAN_SS;
     m_minCwnd = 2;
-};
+}
 
 void
 TcpLedbat::InitCircBuf(OwdCircBuf& buffer)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/internet/model/tcp-prr-recovery.cc ns-3.41/src/internet/model/tcp-prr-recovery.cc
--- ns-3.40/src/internet/model/tcp-prr-recovery.cc	2023-09-27 13:30:37.662839200 -0700
+++ ns-3.41/src/internet/model/tcp-prr-recovery.cc	2024-02-09 14:44:07.941790300 -0800
@@ -35,15 +35,16 @@
 TypeId
 TcpPrrRecovery::GetTypeId()
 {
-    static TypeId tid = TypeId("ns3::TcpPrrRecovery")
-                            .SetParent<TcpClassicRecovery>()
-                            .AddConstructor<TcpPrrRecovery>()
-                            .SetGroupName("Internet")
-                            .AddAttribute("ReductionBound",
-                                          "Type of Reduction Bound",
-                                          EnumValue(SSRB),
-                                          MakeEnumAccessor(&TcpPrrRecovery::m_reductionBoundMode),
-                                          MakeEnumChecker(CRB, "CRB", SSRB, "SSRB"));
+    static TypeId tid =
+        TypeId("ns3::TcpPrrRecovery")
+            .SetParent<TcpClassicRecovery>()
+            .AddConstructor<TcpPrrRecovery>()
+            .SetGroupName("Internet")
+            .AddAttribute("ReductionBound",
+                          "Type of Reduction Bound",
+                          EnumValue(SSRB),
+                          MakeEnumAccessor<ReductionBound_t>(&TcpPrrRecovery::m_reductionBoundMode),
+                          MakeEnumChecker(CRB, "CRB", SSRB, "SSRB"));
     return tid;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/internet/model/tcp-rate-ops.cc ns-3.41/src/internet/model/tcp-rate-ops.cc
--- ns-3.40/src/internet/model/tcp-rate-ops.cc	2023-09-27 13:30:37.662839200 -0700
+++ ns-3.41/src/internet/model/tcp-rate-ops.cc	2024-02-09 14:44:07.941790300 -0800
@@ -183,7 +183,7 @@
 
     if (m_rateSample.m_priorDelivered == 0 || skbInfo.m_delivered > m_rateSample.m_priorDelivered)
     {
-        m_rateSample.m_ackElapsed = Simulator::Now() - m_rateSample.m_priorTime;
+        m_rateSample.m_ackElapsed = Simulator::Now() - skbInfo.m_deliveredTime;
         m_rateSample.m_priorDelivered = skbInfo.m_delivered;
         m_rateSample.m_priorTime = skbInfo.m_deliveredTime;
         m_rateSample.m_isAppLimited = skbInfo.m_isAppLimited;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/internet/model/tcp-socket-base.cc ns-3.41/src/internet/model/tcp-socket-base.cc
--- ns-3.40/src/internet/model/tcp-socket-base.cc	2023-09-27 13:30:37.662839200 -0700
+++ ns-3.41/src/internet/model/tcp-socket-base.cc	2024-02-09 14:44:07.941790300 -0800
@@ -164,7 +164,7 @@
             .AddAttribute("UseEcn",
                           "Parameter to set ECN functionality",
                           EnumValue(TcpSocketState::Off),
-                          MakeEnumAccessor(&TcpSocketBase::SetUseEcn),
+                          MakeEnumAccessor<TcpSocketState::UseEcn_t>(&TcpSocketBase::SetUseEcn),
                           MakeEnumChecker(TcpSocketState::Off,
                                           "Off",
                                           TcpSocketState::On,
@@ -1689,7 +1689,8 @@
     }
 
     // (4.3) Retransmit the first data segment presumed dropped
-    DoRetransmit();
+    uint32_t sz = SendDataPacket(m_highRxAckMark, m_tcb->m_segmentSize, true);
+    NS_ASSERT_MSG(sz > 0, "SendDataPacket returned zero, indicating zero bytes were sent");
     // (4.4) Run SetPipe ()
     // (4.5) Proceed to step (C)
     // these steps are done after the ProcessAck function (SendPendingData)
@@ -1777,8 +1778,8 @@
         // (2) If DupAcks < DupThresh but IsLost (HighACK + 1) returns true
         // (indicating at least three segments have arrived above the current
         // cumulative acknowledgment point, which is taken to indicate loss)
-        // go to step (4).
-        else if (m_txBuffer->IsLost(m_highRxAckMark + m_tcb->m_segmentSize))
+        // go to step (4).  Note that m_highRxAckMark is (HighACK + 1)
+        else if (m_txBuffer->IsLost(m_highRxAckMark))
         {
             EnterRecovery(currentDelivered);
             NS_ASSERT(m_tcb->m_congState == TcpSocketState::CA_RECOVERY);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/internet/model/tcp-tx-buffer.cc ns-3.41/src/internet/model/tcp-tx-buffer.cc
--- ns-3.40/src/internet/model/tcp-tx-buffer.cc	2023-09-27 13:30:37.662839200 -0700
+++ ns-3.41/src/internet/model/tcp-tx-buffer.cc	2024-02-09 14:44:07.941790300 -0800
@@ -926,8 +926,6 @@
 {
     NS_LOG_FUNCTION(this << seq);
 
-    SequenceNumber32 beginOfCurrentPacket = m_firstByteSeq;
-
     if (seq >= m_highestSack.second)
     {
         return false;
@@ -938,7 +936,7 @@
     for (auto it = m_sentList.begin(); it != m_sentList.end(); ++it)
     {
         // Search for the right iterator before calling IsLost()
-        if (beginOfCurrentPacket >= seq)
+        if ((*it)->m_startSeq <= seq && seq < (*it)->m_startSeq + (*it)->m_packet->GetSize())
         {
             if ((*it)->m_lost)
             {
@@ -952,8 +950,6 @@
                 return false;
             }
         }
-
-        beginOfCurrentPacket += (*it)->m_packet->GetSize();
     }
 
     return false;
@@ -1016,7 +1012,7 @@
      */
     if (SizeFromSequence(m_firstByteSeq + m_sentSize) > 0)
     {
-        if (m_sentSize <= m_rWndCallback())
+        if (m_sentSize < m_rWndCallback())
         {
             NS_LOG_INFO("There is unsent data. Send it");
             *seq = m_firstByteSeq + m_sentSize;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/internet/model/tcp-westwood-plus.cc ns-3.41/src/internet/model/tcp-westwood-plus.cc
--- ns-3.40/src/internet/model/tcp-westwood-plus.cc	2023-09-27 13:30:37.666839100 -0700
+++ ns-3.41/src/internet/model/tcp-westwood-plus.cc	2024-02-09 14:44:07.941790300 -0800
@@ -54,7 +54,7 @@
                 "FilterType",
                 "Use this to choose no filter or Tustin's approximation filter",
                 EnumValue(TcpWestwoodPlus::TUSTIN),
-                MakeEnumAccessor(&TcpWestwoodPlus::m_fType),
+                MakeEnumAccessor<FilterType>(&TcpWestwoodPlus::m_fType),
                 MakeEnumChecker(TcpWestwoodPlus::NONE, "None", TcpWestwoodPlus::TUSTIN, "Tustin"))
             .AddTraceSource("EstimatedBW",
                             "The estimated bandwidth",
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/internet/model/udp-socket-impl.cc ns-3.41/src/internet/model/udp-socket-impl.cc
--- ns-3.40/src/internet/model/udp-socket-impl.cc	2023-09-27 13:30:37.666839100 -0700
+++ ns-3.41/src/internet/model/udp-socket-impl.cc	2024-02-09 14:44:07.945790300 -0800
@@ -496,7 +496,7 @@
     }
 
     m_errno = ERROR_AFNOSUPPORT;
-    return (-1);
+    return -1;
 }
 
 int
@@ -695,7 +695,7 @@
 
     if (dest.IsIpv4MappedAddress())
     {
-        return (DoSendTo(p, dest.GetIpv4MappedAddress(), port, 0));
+        return DoSendTo(p, dest.GetIpv4MappedAddress(), port, 0);
     }
     if (m_boundnetdevice)
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/internet/test/tcp-advertised-window-test.cc ns-3.41/src/internet/test/tcp-advertised-window-test.cc
--- ns-3.40/src/internet/test/tcp-advertised-window-test.cc	2023-09-27 13:30:37.666839100 -0700
+++ ns-3.41/src/internet/test/tcp-advertised-window-test.cc	2024-02-09 14:44:07.949790500 -0800
@@ -81,7 +81,7 @@
     void SetExpectedSegmentSize(uint16_t seg)
     {
         m_segmentSize = seg;
-    };
+    }
 
   protected:
     Ptr<TcpSocketBase> Fork() override;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/internet/test/tcp-rtt-estimation.cc ns-3.41/src/internet/test/tcp-rtt-estimation.cc
--- ns-3.40/src/internet/test/tcp-rtt-estimation.cc	2023-09-27 13:30:37.670839000 -0700
+++ ns-3.41/src/internet/test/tcp-rtt-estimation.cc	2024-02-09 14:44:07.949790500 -0800
@@ -234,7 +234,7 @@
 
     for (auto it = m_toDrop.begin(); it != m_toDrop.end(); ++it)
     {
-        errorModel->AddSeqToKill(SequenceNumber32((*it)));
+        errorModel->AddSeqToKill(SequenceNumber32(*it));
     }
 
     return errorModel;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/internet-apps/CMakeLists.txt ns-3.41/src/internet-apps/CMakeLists.txt
--- ns-3.40/src/internet-apps/CMakeLists.txt	2023-09-27 13:30:37.646839100 -0700
+++ ns-3.41/src/internet-apps/CMakeLists.txt	2024-02-09 14:44:07.913790200 -0800
@@ -3,36 +3,28 @@
   SOURCE_FILES
     helper/dhcp-helper.cc
     helper/ping-helper.cc
-    helper/ping6-helper.cc
     helper/radvd-helper.cc
-    helper/v4ping-helper.cc
     helper/v4traceroute-helper.cc
     model/dhcp-client.cc
     model/dhcp-header.cc
     model/dhcp-server.cc
     model/ping.cc
-    model/ping6.cc
     model/radvd-interface.cc
     model/radvd-prefix.cc
     model/radvd.cc
-    model/v4ping.cc
     model/v4traceroute.cc
   HEADER_FILES
     helper/dhcp-helper.h
     helper/ping-helper.h
-    helper/ping6-helper.h
     helper/radvd-helper.h
-    helper/v4ping-helper.h
     helper/v4traceroute-helper.h
     model/dhcp-client.h
     model/dhcp-header.h
     model/dhcp-server.h
     model/ping.h
-    model/ping6.h
     model/radvd-interface.h
     model/radvd-prefix.h
     model/radvd.h
-    model/v4ping.h
     model/v4traceroute.h
   LIBRARIES_TO_LINK ${libinternet}
   TEST_SOURCES
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/internet-apps/model/dhcp-header.cc ns-3.41/src/internet-apps/model/dhcp-header.cc
--- ns-3.40/src/internet-apps/model/dhcp-header.cc	2023-09-27 13:30:37.646839100 -0700
+++ ns-3.41/src/internet-apps/model/dhcp-header.cc	2024-02-09 14:44:07.913790200 -0800
@@ -338,7 +338,7 @@
     {
         i.WriteU8(OP_MSGTYPE);
         i.WriteU8(1);
-        i.WriteU8((m_op + 1));
+        i.WriteU8(m_op + 1);
     }
     if (m_opt[OP_ADDREQ])
     {
@@ -383,8 +383,8 @@
 DhcpHeader::Deserialize(Buffer::Iterator start)
 {
     uint32_t len;
-    uint32_t clen = start.GetSize();
-    if (clen < 240)
+    uint32_t cLen = start.GetSize();
+    if (cLen < 240)
     {
         NS_LOG_WARN("Malformed Packet");
         return 0;
@@ -416,7 +416,7 @@
     bool loop = true;
     do
     {
-        if (len + 1 <= clen)
+        if (len + 1 <= cLen)
         {
             option = i.ReadU8();
             len += 1;
@@ -429,7 +429,7 @@
         switch (option)
         {
         case OP_MASK:
-            if (len + 5 < clen)
+            if (len + 5 < cLen)
             {
                 i.ReadU8();
                 m_mask = i.ReadNtohU32();
@@ -442,7 +442,7 @@
             }
             break;
         case OP_ROUTE:
-            if (len + 5 < clen)
+            if (len + 5 < cLen)
             {
                 i.ReadU8();
                 ReadFrom(i, m_route);
@@ -455,7 +455,7 @@
             }
             break;
         case OP_MSGTYPE:
-            if (len + 2 < clen)
+            if (len + 2 < cLen)
             {
                 i.ReadU8();
                 m_op = (i.ReadU8() - 1);
@@ -468,7 +468,7 @@
             }
             break;
         case OP_SERVID:
-            if (len + 5 < clen)
+            if (len + 5 < cLen)
             {
                 i.ReadU8();
                 ReadFrom(i, m_dhcps);
@@ -481,7 +481,7 @@
             }
             break;
         case OP_ADDREQ:
-            if (len + 5 < clen)
+            if (len + 5 < cLen)
             {
                 i.ReadU8();
                 ReadFrom(i, m_req);
@@ -494,7 +494,7 @@
             }
             break;
         case OP_LEASE:
-            if (len + 5 < clen)
+            if (len + 5 < cLen)
             {
                 i.ReadU8();
                 m_lease = i.ReadNtohU32();
@@ -507,7 +507,7 @@
             }
             break;
         case OP_RENEW:
-            if (len + 5 < clen)
+            if (len + 5 < cLen)
             {
                 i.ReadU8();
                 m_renew = i.ReadNtohU32();
@@ -520,7 +520,7 @@
             }
             break;
         case OP_REBIND:
-            if (len + 5 < clen)
+            if (len + 5 < cLen)
             {
                 i.ReadU8();
                 m_rebind = i.ReadNtohU32();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/internet-apps/model/ping.cc ns-3.41/src/internet-apps/model/ping.cc
--- ns-3.40/src/internet-apps/model/ping.cc	2023-09-27 13:30:37.646839100 -0700
+++ ns-3.41/src/internet-apps/model/ping.cc	2024-02-09 14:44:07.913790200 -0800
@@ -69,7 +69,7 @@
             .AddAttribute("VerboseMode",
                           "Configure verbose, quiet, or silent output",
                           EnumValue(VerboseMode::VERBOSE),
-                          MakeEnumAccessor(&Ping::m_verbose),
+                          MakeEnumAccessor<VerboseMode>(&Ping::m_verbose),
                           MakeEnumChecker(VerboseMode::VERBOSE,
                                           "Verbose",
                                           VerboseMode::QUIET,
@@ -103,6 +103,12 @@
                           TimeValue(Seconds(1)),
                           MakeTimeAccessor(&Ping::m_timeout),
                           MakeTimeChecker())
+            .AddAttribute("Tos",
+                          "The Type of Service used to send the ICMP Echo Requests. "
+                          "All 8 bits of the TOS byte are set (including ECN bits).",
+                          UintegerValue(0),
+                          MakeUintegerAccessor(&Ping::m_tos),
+                          MakeUintegerChecker<uint8_t>())
             .AddTraceSource("Tx",
                             "The sequence number and ICMP echo response packet.",
                             MakeTraceSourceAccessor(&Ping::m_txTrace),
@@ -455,8 +461,9 @@
             header.EnableChecksum();
         }
         p->AddHeader(header);
-        returnValue =
-            m_socket->SendTo(p, 0, InetSocketAddress(Ipv4Address::ConvertFrom(m_destination), 0));
+        auto dest = InetSocketAddress(Ipv4Address::ConvertFrom(m_destination), 0);
+        dest.SetTos(m_tos);
+        returnValue = m_socket->SendTo(p, 0, dest);
     }
     else
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/internet-apps/model/ping.h ns-3.41/src/internet-apps/model/ping.h
--- ns-3.40/src/internet-apps/model/ping.h	2023-09-27 13:30:37.646839100 -0700
+++ ns-3.41/src/internet-apps/model/ping.h	2024-02-09 14:44:07.913790200 -0800
@@ -213,6 +213,8 @@
     uint32_t m_size{56};
     /// The socket we send packets from
     Ptr<Socket> m_socket;
+    /// The Type of Service carried by ICMP ECHOs
+    uint8_t m_tos;
     /// ICMP ECHO sequence number
     uint16_t m_seq{0};
     /// Callbacks for tracing the packet Tx events
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/lr-wpan/CMakeLists.txt ns-3.41/src/lr-wpan/CMakeLists.txt
--- ns-3.40/src/lr-wpan/CMakeLists.txt	2023-09-27 13:30:37.670839000 -0700
+++ ns-3.41/src/lr-wpan/CMakeLists.txt	2024-02-09 14:44:07.953790400 -0800
@@ -10,6 +10,7 @@
     model/lr-wpan-mac-header.cc
     model/lr-wpan-mac-pl-headers.cc
     model/lr-wpan-mac-trailer.cc
+    model/lr-wpan-mac-base.cc
     model/lr-wpan-mac.cc
     model/lr-wpan-net-device.cc
     model/lr-wpan-phy.cc
@@ -26,17 +27,13 @@
     model/lr-wpan-mac-header.h
     model/lr-wpan-mac-pl-headers.h
     model/lr-wpan-mac-trailer.h
+    model/lr-wpan-mac-base.h
     model/lr-wpan-mac.h
     model/lr-wpan-net-device.h
     model/lr-wpan-phy.h
     model/lr-wpan-spectrum-signal-parameters.h
     model/lr-wpan-spectrum-value-helper.h
-  LIBRARIES_TO_LINK
-    ${libnetwork}
-    ${libcore}
-    ${libmobility}
-    ${libspectrum}
-    ${libpropagation}
+  LIBRARIES_TO_LINK ${libspectrum}
   TEST_SOURCES
     test/lr-wpan-ack-test.cc
     test/lr-wpan-cca-test.cc
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/lr-wpan/examples/lr-wpan-active-scan.cc ns-3.41/src/lr-wpan/examples/lr-wpan-active-scan.cc
--- ns-3.40/src/lr-wpan/examples/lr-wpan-active-scan.cc	2023-09-27 13:30:37.670839000 -0700
+++ ns-3.41/src/lr-wpan/examples/lr-wpan-active-scan.cc	2024-02-09 14:44:07.953790400 -0800
@@ -56,7 +56,7 @@
 static void
 ScanConfirm(Ptr<LrWpanNetDevice> device, MlmeScanConfirmParams params)
 {
-    if (params.m_status == MLMESCAN_SUCCESS)
+    if (params.m_status == LrWpanMacStatus::SUCCESS)
     {
         std::cout << Simulator::Now().As(Time::S) << "| Active scan status SUCCESSFUL (Completed)"
                   << "\n";
